/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookPageConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookPageConnectorForm{}

// FacebookPageConnectorForm struct for FacebookPageConnectorForm
type FacebookPageConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label string `json:"label"`
	// Facebook Page ID.
	PageId string `json:"pageId"`
	// Metrics
	Metric []string `json:"metric"`
	// Data labels
	DataLabel []string `json:"dataLabel"`
	// Data range expression
	DateRange string `json:"dateRange"`
}

// NewFacebookPageConnectorForm instantiates a new FacebookPageConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookPageConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, pageId string, metric []string, dataLabel []string, dateRange string) *FacebookPageConnectorForm {
	this := FacebookPageConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.PageId = pageId
	this.Metric = metric
	this.DataLabel = dataLabel
	this.DateRange = dateRange
	return &this
}

// NewFacebookPageConnectorFormWithDefaults instantiates a new FacebookPageConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookPageConnectorFormWithDefaults() *FacebookPageConnectorForm {
	this := FacebookPageConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *FacebookPageConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *FacebookPageConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *FacebookPageConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *FacebookPageConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *FacebookPageConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *FacebookPageConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *FacebookPageConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *FacebookPageConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *FacebookPageConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *FacebookPageConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *FacebookPageConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *FacebookPageConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *FacebookPageConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetPageId returns the PageId field value
func (o *FacebookPageConnectorForm) GetPageId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetPageIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageId, true
}

// SetPageId sets field value
func (o *FacebookPageConnectorForm) SetPageId(v string) {
	o.PageId = v
}

// GetMetric returns the Metric field value
func (o *FacebookPageConnectorForm) GetMetric() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metric, true
}

// SetMetric sets field value
func (o *FacebookPageConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value
func (o *FacebookPageConnectorForm) GetDataLabel() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetDataLabelOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DataLabel, true
}

// SetDataLabel sets field value
func (o *FacebookPageConnectorForm) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetDateRange returns the DateRange field value
func (o *FacebookPageConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *FacebookPageConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *FacebookPageConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

func (o FacebookPageConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookPageConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["pageId"] = o.PageId
	toSerialize["metric"] = o.Metric
	toSerialize["dataLabel"] = o.DataLabel
	toSerialize["dateRange"] = o.DateRange
	return toSerialize, nil
}

type NullableFacebookPageConnectorForm struct {
	value *FacebookPageConnectorForm
	isSet bool
}

func (v NullableFacebookPageConnectorForm) Get() *FacebookPageConnectorForm {
	return v.value
}

func (v *NullableFacebookPageConnectorForm) Set(val *FacebookPageConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookPageConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookPageConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookPageConnectorForm(val *FacebookPageConnectorForm) *NullableFacebookPageConnectorForm {
	return &NullableFacebookPageConnectorForm{value: val, isSet: true}
}

func (v NullableFacebookPageConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookPageConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
